# Generated by Django 2.2.22 on 2021-06-09 10:21

from django.conf import settings
import django.core.validators
from django.db import migrations, models
import django.db.models.deletion
import django.utils.timezone
import uuid


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ('stocks', '0001_initial'),
    ]

    operations = [
        migrations.CreateModel(
            name='Game',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.TextField()),
                ('token', models.UUIDField(default=uuid.uuid4)),
                ('start_date', models.DateField()),
                ('embargo_date', models.DateField(null=True)),
                ('end_date', models.DateField()),
                ('max_portfolios', models.IntegerField(default=3, null=True)),
                ('max_portfolio_revisions', models.IntegerField(default=10, null=True)),
                ('max_portfolio_assets', models.IntegerField(default=4, null=True)),
                ('assets', models.ManyToManyField(to='stocks.Asset')),
                ('index', models.ForeignKey(null=True, on_delete=django.db.models.deletion.PROTECT, to='stocks.Index')),
            ],
        ),
        migrations.CreateModel(
            name='Participation',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('game', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='game.Game')),
                ('user', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
        ),
        migrations.CreateModel(
            name='Portfolio',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.TextField()),
                ('participation', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='game.Participation')),
            ],
        ),
        migrations.CreateModel(
            name='PortfolioRevision',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created_at', models.DateTimeField(default=django.utils.timezone.now)),
                ('date', models.DateField()),
                ('portfolio', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='game.Portfolio')),
            ],
        ),
        migrations.CreateModel(
            name='PortfolioAsset',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('weight', models.IntegerField(validators=[django.core.validators.MinValueValidator(-100), django.core.validators.MaxValueValidator(100)])),
                ('asset', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, to='stocks.Asset')),
                ('portfolio_revision', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='game.PortfolioRevision')),
            ],
        ),
        migrations.AddConstraint(
            model_name='portfoliorevision',
            constraint=models.UniqueConstraint(fields=('portfolio', 'date'), name='unique_date'),
        ),
        migrations.AddConstraint(
            model_name='portfolioasset',
            constraint=models.UniqueConstraint(fields=('portfolio_revision', 'asset'), name='unique_portfolio_asset'),
        ),
        migrations.AddConstraint(
            model_name='participation',
            constraint=models.UniqueConstraint(fields=('game', 'user'), name='unique_game'),
        ),
    ]
