"""Restframework serializers for stocks models"""

from rest_framework import serializers
from .models import Asset, Index


class AssetSerializer(serializers.ModelSerializer):
    """Restframework serializer for Assets"""

    class Meta:
        model = Asset
        fields = ['pk', 'isin', 'name', 'ticker']


class IndexSerializer(serializers.ModelSerializer):
    """Restframework serializer for Indexes"""

    assets = serializers.PrimaryKeyRelatedField(
        queryset=Asset.objects.all(),
        many=True,
        allow_empty=True,
    )

    class Meta:
        model = Index
        fields = ['pk', 'name', 'assets']
