"""
This (hand-written) data migration adds some initial users.
"""

from django.db import migrations


def add_initial_users(apps, schema_editor):
    """
    Just add the initial users.
    Set is_staff to True so they can access the admin bits.
    """

    User = apps.get_model('uvt', 'User')
    defaults = {
        'is_staff': True,
        'is_admin': True,
    }
	# If you change to this list, please also update
	# tools/generate_uvt_fixtures.py
    users = {
        'schmeits': {'anr': '135447'},
        'hmiesen': {'anr': '749796'},
        'hvddool': {'anr': '628026'},
        'wsl': {'anr': '488937'},
        'pdeg': {'anr': '311111'},
        'svermeul': {'anr': '206605'},
    }
    for username, extra in users.items():
        User.objects.update_or_create(
            username=username,
            defaults={**defaults, **extra},
        )


class Migration(migrations.Migration):
    """Standard Django migration class"""

    dependencies = [
        ('uvt', '0001_initial'),
    ]

    operations = [
        migrations.RunPython(add_initial_users),
    ]
