"""Models for the UvT app"""

from django.db import models
from django.contrib.auth.models import AbstractUser


class User(AbstractUser):
    """Standard Django User augmented with UvT specific stuff"""
    anr = models.CharField(max_length=6, unique=True, null=True)
    student_number = models.CharField(max_length=7, unique=True, null=True)
    full_name = models.TextField(null=True)
    last_ldap_sync = models.DateTimeField(null=True)
    is_admin = models.BooleanField(default=False)

    def get_full_name(self):
        return self.full_name
